m4_changequote([,])m4_ifelse([

Some simple list manipulating macros. Can be tested with the
following:

m4_memberP(b,a,b,c)=yes
m4_memberP(x,a,b,c)=no
m4_successor(a,a,b,c)=b
m4_successor(b,a,b,c)=c
m4_successor(c,a,b,c)=
m4_successor(x,a,b,c)=
m4_reverselist(a,b,c,d)=d,c,b,a
m4_reverselist()=
m4_reverselist=
m4_predecessor(a,a,b,c)=
m4_predecessor(b,a,b,c)=a
m4_predecessor(c,a,b,c)=b
m4_predecessor(x,a,b,c)=
m4_foreach(`*$1*', a,b,c)
m4_first(a,b,c,d,e)=a
m4_last(a,b,c,d,e)=e
m4_length(a,b,c)=3
m4_any(l1)=yes
m4_any()=no

])m4_changequote
m4_dnl
m4_dnl ***    m4_memberP: checks whether `$1' is any of `m4_shift($@)'.
m4_dnl        ~~~~~~~~~~~ Returns `yes' or `no'.
m4_dnl
m4_define(`m4_memberP', 
  `m4_ifelse($#,0,`m4_errprint(`--error: m4_memberP called with 0 arguments')',
             $#,1,`no',
             $2,,`no',
             $1,$2,`yes',
             `$0($1, m4_shift(m4_shift($@)))')')
m4_dnl
m4_dnl ***    m4_successor: gets element after `$1' in `m4_shift($@)'.
m4_dnl        ~~~~~~~~~~~~~ Returns found element or `'.
m4_dnl
m4_define(`m4_successor', 
  `m4_ifelse($#,0,
               `m4_errprint(`--error: m4_successor called with 0 arguments.')',
             $3,,,
             $1,$2,$3,
             `$0($1, m4_shift(m4_shift($@)))')')
m4_dnl
m4_dnl ***   m4_reverselist: reverses the order of the arguments.
m4_dnl       ~~~~~~~~~~~~~~~ Returns comma separated list.
m4_dnl
m4_define(`m4_reverselist', 
  `m4_ifelse($#,0,,$#,1,$1,`$0(m4_shift($@)),$1')')
m4_dnl
m4_dnl ***   m4_predecessor: gets the element preceding `$1' in `m4_shift($@)'.
m4_dnl       ~~~~~~~~~~~~~~~ Returns found element or `'.
m4_dnl
m4_define(`m4_predecessor', `m4_successor($1, m4_reverselist(m4_shift($@)))')
m4_dnl
m4_dnl ***   m4_foreach: applies `$1' to each of the `m4_shift($@)'.
m4_dnl       ~~~~~~~~~~~ Returns concatenation of expansions of `$1'.
m4_dnl
m4_define(`m4_foreach', 
  `m4_ifelse($2,,,`m4_pushdef(`_exe_', `$1')_exe_($2)`'m4_popdef(`_exe_')$0(`$1', m4_shift(m4_shift($@)))')')
m4_dnl
m4_dnl ***   m4_first: returns `$1'.
m4_dnl       ~~~~~~~~~
m4_define(`m4_first', `$1')
m4_dnl
m4_dnl ***   m4_last: returns last element of the list.
m4_dnl       ~~~~~~~~
m4_define(`m4_last', 
  `m4_ifelse($#,0,,$#,1,$1,`$0(m4_shift($@))')')
m4_dnl
m4_dnl ***   m4_length: returns the length of the list.
m4_dnl       ~~~~~~~~~~
m4_define(`m4_length', `$#')
m4_dnl
m4_dnl ***   m4_any: Returns whether or not the list has any elements.
m4_dnl       ~~~~~~~
m4_define(`m4_any', 
    `m4_pushdef(`_AnY_',`no')m4_foreach(`m4_define(`_AnY_',
           `yes')',$@)_AnY_`'m4_popdef(`_AnY_')')
