m4_dnl   Some macros for dealing with type _type_'s components (#real only):
m4_dnl                a.r., 2000-09-05, 2000-09-14

m4_dnl   _type_, _type_fillargs_ must be defined, e.g.:
m4_dnl     m4_define(`_type_', `tQ')
m4_dnl     m4_define(`_type_fillargs_', `tQ_tRho_tNode')

m4_dnl   Beware that export... must not be inside a comment!
m4_dnl    It takes as arguments the names of
m4_dnl    (1) the module receiving the information and defining the type, and
m4_dnl    (2) the module providing the information, calling export...

m4_dnl   If you do not want to have a simple assignment, you must have a
m4_dnl    @ in your definition text. Any @s are removed. - Furthermore,
m4_dnl    any occurrence of @@ inhibits inclusion in private_fill...__... .

m4_dnl   You can check whether or not you actually defined _type_'s
m4_dnl    component x via m4_ifdef(`I defined _type_ x.', ...) (though
m4_dnl    this is clearly a bit baroque).

m4_define(`_'_type_`_components')
m4_define(`_'_type_`_compdeclars')
m4_define(`fill'_type_`__'_type_fillargs_)
m4_define(`private_fill'_type_`__'_type_fillargs_)

m4_define(`new'_type_`', `register'_type_`($1, `real (kind=KIND_real)',
                                           $2, $3)')

m4_changequote([[[,]]])
m4_define([[[register]]]_type_,
 [[[m4_pushdef(`_]]]_type_[[[_aux',m4_translit(`.$1.',`a-z',`A-Z'))
    m4_ifelse(m4_index(_]]]_type_[[[_components,_]]]_type_[[[_aux),`-1',
        `m4_define(`I defined ]]]_type_[[[ $1.')
         m4_define(`_]]]_type_[[[_components',
                m4_defn(`_]]]_type_[[[_components')_]]]_type_[[[_aux)
         m4_define(`_]]]_type_[[[_compdeclars',
                   m4_defn(`_]]]_type_[[[_compdeclars')`
$2 :: $1')m4_ifelse(m4_len($4),0,,
            `m4_define(`fill]]]_type_[[[__]]]_type_fillargs_[[[',
                m4_defn(`fill]]]_type_[[[__]]]_type_fillargs_[[[')`
'm4_ifelse(m4_index(`$4',`@'),-1,$3%$1 = )m4_translit(`$4',`@'))')
')m4_ifelse(m4_len($4),0,,m4_index(`$4',`@@'),-1,
    `m4_define(`private_fill]]]_type_[[[__]]]_type_fillargs_[[[',
                m4_defn(`private_fill]]]_type_[[[__]]]_type_fillargs_[[[')`
'm4_ifelse(m4_index(`$4',`@'),-1,$3%$1 = )m4_translit(`$4',`@'))')m4_popdef(
`_]]]_type_[[[_aux')]]])m4_changequote



m4_define(`import'_type_,
    `m4_include(m4_translit(.f90/type-'_type_`.$1.inc,`A-Z',`a-z'))')



m4_changequote([[[,]]])
m4_define([[[export]]]_type_,[[[m4_changequote(|m4:,:m4|)
<:{local *STDOUT;open(STDOUT,">.f90/m4_translit(type-]]]_type_[[[.$2.inc,A-Z,a-z)"):>
|m4:m4_define(`_]]]_type_[[[_components',:m4|
    `m4_defn(|m4:_]]]_type_[[[_components:m4|)')
<:}:>
<:{local *STDOUT;open(STDOUT,">.f90/m4_translit($1.$2.]]]_type_[[[.inc,A-Z,a-z)"):>
_]]]_type_[[[_compdeclars
<:}:>
<:{local *STDOUT;open(STDOUT,">.f90/m4_translit($1.$2.fill]]]_type_[[[.inc,A-Z,a-z)"):>
|m4:m4_define(`fill]]]_type_[[[__]]]_type_fillargs_[[[',:m4|
    `m4_defn(|m4:fill]]]_type_[[[__]]]_type_fillargs_[[[:m4|)')
<:}:>
m4_changequote]]])
m4_changequote



